/* icontools.c */
/* Farbe funktioniert (noch) nicht! */

#include <alloc.h>

#define NO_DUMP_ICON_DATA

#ifdef DUMP_ICON_DATA
void DumpIconBmpData(ICONINFO *IconInfoRec)
{ BITMAP bmand, bmxor;
  char Zeile[2000];
  int X, Y;
  static int do_it = 1;
  HDC hdc;
  GetObject(IconInfoRec->hbmMask, sizeof(bmand), &bmand);
  GetObject(IconInfoRec->hbmColor, sizeof(bmxor), &bmxor);
  sprintf(Zeile, "AND-Bitmap - %d * %d, %d Planes, %d Bits per Pixel\n"
                 "XOR-Bitmap - %d * %d, %d Planes, %d Bits per Pixel",
    bmand.bmWidth, bmand.bmHeight, bmand.bmPlanes, bmand.bmBitsPixel,
    bmxor.bmWidth, bmxor.bmHeight, bmxor.bmPlanes, bmxor.bmBitsPixel);
  if ((hdc = GetDC(NULL)) != NULL) {
    SelectObject(hdc, IconInfoRec->hbmColor);
    for (Y = 0; Y < bmxor.bmHeight ; Y++) {
      strcat(Zeile, "\n");
      for (X = 0; X < bmxor.bmWidth; X++)
        sprintf(&(Zeile[strlen(Zeile)]), " %.6lx", (unsigned long) GetPixel(hdc, X, Y));
    }
    ReleaseDC(NULL, hdc);
  }
  if (MessageBox(NULL, Zeile, "ICON Data", MB_ICONINFORMATION | MB_OKCANCEL) == IDCANCEL) do_it = 0;
}

void DumpIconData(int nWidth, int nHeight, int Colorplanes,
                  int width_bytes_and, int width_bytes_xor,
                  unsigned char *AND_Bytes, unsigned char *XOR_Bytes, int first)
{ char Zeile[2000];
  int X, Y;
  static int do_it = 1;
  if (first) do_it = 1;
  if (!do_it) return;
  sprintf(Zeile, "CreateIcon(hInstance, %d, %d, 1, %d, ...", nWidth, nHeight, Colorplanes);
  sprintf(&(Zeile[strlen(Zeile)]), "\nAND-Bytes per Line: %d, XOR-Bytes per Line: %d\n"
    "XOR_Pointer = 0x%.8lx",
    width_bytes_and, width_bytes_xor, (unsigned long) XOR_Bytes);
  if (XOR_Bytes != NULL) 
  for (Y = 0; Y < nHeight ; Y++) {
    strcat(Zeile, "\n&");
    for (X = 0; X < width_bytes_and; X++)
      sprintf(&(Zeile[strlen(Zeile)]), " %.2x", (unsigned int) AND_Bytes[Y * width_bytes_and + X]);
    if (nHeight > 16) strcat(Zeile, "  ^"); else strcat(Zeile, "\n^");
    for (X = 0; X < width_bytes_xor; X++)
      sprintf(&(Zeile[strlen(Zeile)]), " %.2x", (unsigned int) XOR_Bytes[Y * width_bytes_xor + X]);
  }
  if (MessageBox(NULL, Zeile, "ICON Data", MB_ICONINFORMATION | MB_OKCANCEL) == IDCANCEL) do_it = 0;
}
#endif

HICON CreateIconString(HINSTANCE hInstance,
		       int nWidth, int nHeight,
		       int nWidthMul, int nHeightMul,
		       int Color,
		       char *Data)
{ int width_bytes_and, width_bytes_xor;
  static int AND_Bytes_allocated = 0;
  static int XOR_Bytes_allocated = 0;
  static unsigned char *AND_Bytes = NULL;
  static unsigned char *XOR_Bytes = NULL;
  int plauf, pmerk, Y, Yr, X, Xr, Farbe, byte, bit;
  HDC hdc;
  COLORREF CR;
  HICON icon;
  ICONINFO IconInfoRec;

  width_bytes_and = (nWidth + 7) / 8;
  if (width_bytes_and & 1) width_bytes_and++;
  if ((AND_Bytes == NULL) || (AND_Bytes_allocated < width_bytes_and * nHeight)) {
    if (AND_Bytes != NULL) { free(AND_Bytes); AND_Bytes_allocated = 0; }
    if ((AND_Bytes = malloc(width_bytes_and * nHeight)) == NULL) return NULL;
    AND_Bytes_allocated = width_bytes_and * nHeight;
  }
  memset(AND_Bytes, 0, AND_Bytes_allocated);

  if (Color) {
    if ((hdc = GetDC(NULL)) == NULL) return NULL;
    if ((IconInfoRec.hbmColor = CreateCompatibleBitmap(hdc, nWidth, nHeight)) == NULL) {
      ReleaseDC(NULL, hdc);
      return NULL;
    }
    SelectObject(hdc, IconInfoRec.hbmColor);
    // GetObject(hbmp, sizeof(bm), &bm);
  } else {
    width_bytes_xor = (nWidth + 7) / 8;
    if ((XOR_Bytes == NULL) || (XOR_Bytes_allocated < width_bytes_xor * nHeight)) {
      if (XOR_Bytes != NULL) { free(XOR_Bytes); XOR_Bytes_allocated = 0; }
      if ((XOR_Bytes = malloc(width_bytes_xor * nHeight)) == NULL) return NULL;
      XOR_Bytes_allocated = width_bytes_xor * nHeight;
    }
    memset(XOR_Bytes, 0, XOR_Bytes_allocated);
  }

  pmerk = 0;

  Yr = nHeightMul;
  for (Y = 0; Y < nHeight; Y++) {
    plauf = pmerk;
    Xr = nWidthMul;
    for (X = 0; X < nWidth; X++) {
      Farbe = -1;
      switch (Data[plauf]) {
	case ' ':           Farbe = -1; /* durchsichtig */ break;
	case '/':           Farbe = -2; /* invertieren  */ break;
	case '.': case 'w': Farbe = 15; CR = RGB(255, 255, 255); /* Weiss        */ break;
	case 'K': case '#': Farbe =  0; CR = RGB(  0,   0,   0); /* Schwarz      */ break;
	case 'b':           Farbe =  1; CR = RGB(  0,   0, 255); /* Blau         */ break;
	case 'g':           Farbe =  2; CR = RGB(  0, 255,   0); /* Grn         */ break;
	case 'c':           Farbe =  3; CR = RGB(  0, 255, 255); /* Cyanblau     */ break;
	case 'r':           Farbe =  4; CR = RGB(255,   0,   0); /* Rot          */ break;
	case 'm':           Farbe =  5; CR = RGB(255,   0, 255); /* Magentarot   */ break;
	case 'y':           Farbe =  6; CR = RGB(255, 255,   0); /* Gelb         */ break;
	case 'l':           Farbe =  7; CR = RGB(192, 192, 192); /* Hellgrau     */ break;
	case 'D':           Farbe =  8; CR = RGB(128, 128, 128); /* Dunkelgrau   */ break;
	case 'B':           Farbe =  9; CR = RGB(  0,   0, 128); /* Dunkelblau   */ break;
	case 'G':           Farbe = 10; CR = RGB(  0, 128,   0); /* Dunkelgrn   */ break;
	case 'C':           Farbe = 11; CR = RGB(  0, 128, 128); /* Dunkelcyan   */ break;
	case 'R':           Farbe = 12; CR = RGB(128,   0,   0); /* Dunkelrot    */ break;
	case 'M':           Farbe = 13; CR = RGB(128,   0, 128); /* Lila         */ break;
	case 'Y':           Farbe = 14; CR = RGB(128, 128,   0); /* Braun        */ break;
      }
      if (Farbe < 0) {
	byte = width_bytes_and * Y + (X / 8);
	bit = 7 - (X & 7);
        AND_Bytes[byte] |= (1 << bit);
	if (Farbe == -2) { Farbe = 15; CR = RGB(255, 255, 255); } else { Farbe = 0; CR = RGB(0, 0, 0); }
      }
      if (Color) {
	SetPixel(hdc, X, Y, CR);
      } else {
	byte = width_bytes_and * Y + (X / 8);
        bit = 7 - (X & 7);
        if (Farbe) XOR_Bytes[byte] |= (1 << bit);
#ifdef DUMP_ICON_DATA
          DumpIconData(nWidth, nHeight, Color ? 4 : 1, width_bytes_and, width_bytes_xor, AND_Bytes, XOR_Bytes,
	    (X == 0) && (Y == 0));
#endif
      }
      if (!(--Xr)) {
        Xr = nWidthMul;
        if (Data[plauf]) plauf++;
      }
    }
    if (!(--Yr)) {
      Yr = nHeightMul;
      pmerk = plauf;
    }
  }
#ifdef DUMP_ICON_DATA
  if (!Color)
  { char Zeile[2000];
    sprintf(Zeile, "CreateIcon(hInstance, %d, %d, 1, %d, ...", nWidth, nHeight, Color ? 4 : 1);
    for (Y = 0; Y < nHeight; Y++) {
      strcat(Zeile, "\n&");
      for (X = 0; X < width_bytes_and; X++)
        sprintf(&(Zeile[strlen(Zeile)]), " %.2x", (unsigned int) AND_Bytes[Y * width_bytes_and + X]);
      strcat(Zeile, "\n^");
      for (X = 0; X < width_bytes_xor; X++)
        sprintf(&(Zeile[strlen(Zeile)]), " %.2x", (unsigned int) XOR_Bytes[Y * width_bytes_xor + X]);
    }
    MessageBox(NULL, Zeile, "ICON Data", MB_ICONINFORMATION | MB_OK);
  }
#endif
  if (Color) {
    // DumpIconData(nWidth, nHeight, GetDeviceCaps(hdc, PLANES) * GetDeviceCaps(hdc, BITSPIXEL),
    //   width_bytes_and, bm.bmWidthBytes, AND_Bytes, bm.bmBits);
    // DumpIconData(nWidth, nHeight, -1, width_bytes_and, width_bytes_xor, AND_Bytes, XOR_Bytes);
   
    IconInfoRec.fIcon = TRUE;
    IconInfoRec.xHotspot = IconInfoRec.yHotspot = 0;
    IconInfoRec.hbmMask = CreateBitmap(nWidth, nHeight, 1, 1, AND_Bytes);
#ifdef DUMP_ICON_DATA
    DumpIconBmpData(&IconInfoRec);
#endif
    icon = CreateIconIndirect(&IconInfoRec);
    ReleaseDC(NULL, hdc); // DeleteObject(IconInfoRec.hbmColor); DeleteObject(IconInfoRec.hbmMask);
    return icon;
  } else
    return (CreateIcon(hInstance, nWidth, nHeight, 1, 1, AND_Bytes, XOR_Bytes));
}
                   
